SystemOrganization addCategory: #'OrbeonPersistenceApiProcess'!

Object subclass: #OrbeonFormPostRegistry
	instanceVariableNames: 'forms formsHistory requestCache'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApiProcess'!

!OrbeonFormPostRegistry class methodsFor: 'other' stamp: 'BrunoBB 06/11/2014 06:37'!
default

	Default ifNil: [ Default := super new initialize].

	^Default! !

!OrbeonFormPostRegistry class methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:31'!
default: anObject

	Default := anObject.

	^Default! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 09/05/2014 05:55'!
addRequest: aRequest

	^requestCache add: aRequest! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:25'!
addToHistory: anObject

	formsHistory add: anObject! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 06:36'!
forms

   "Return the value of the instance variable 'forms'."
   ^forms! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 06:36'!
forms: newValue

   "Modify the value of the instance variable 'forms'."
   forms := newValue! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 06:36'!
formsHistory

   "Return the value of the instance variable 'formsHistory'."
   ^formsHistory! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 06:36'!
formsHistory: newValue

   "Modify the value of the instance variable 'formsHistory'."
   formsHistory := newValue! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:37'!
getForm: id

	^forms at: id ifAbsent: ['']! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 09/05/2014 05:50'!
initialize

	super initialize.

	forms := Dictionary new.
	formsHistory := OrderedCollection new.
	requestCache := OrderedCollection new.! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/23/2015 11:27'!
registerAnnonimousXML: xmlString app: app form: form id: id
	"The receiver register a XML <xmlString> of the OrbeonApplication named <app> of the OrbeonFormDefinition named <form> with an Orbeon database ID <id>.
	1- Import the data in the  XML as an OrbeonFormInstance <formObject>."
	| formObject domainObject oop  |

	forms at: (app,'.',form,'.',id) put: xmlString. 
	"create an OrbeonFormInstance -Form Administrator-"
	[formObject := OrbeonHandler default importDataOfFormId: id form: form app: app] on: Error 
		do: [:ex| ^OrbeonPostResult exception: ex].

	formObject ifNil: [^OrbeonPostResult exception: (FormIdNotExistException signal: 'Form [', form, '] of app [', app, '] with id [', id,'] not found')].

	^OrbeonPostResult result: formObject! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 09:47'!
registerXML: xmlString app: app form: form id: id language: lan valid: valid
	"The receiver register a XML <xmlString> of the OrbeonApplication named <app> of the OrbeonFormDefinition named <form> with an Orbeon database ID <id>.
	1- Import the data in the  XML as an OrbeonFormInstance <formObject>.
	2- Get the Domain Object with the oop in the form.
	3- Associate the Domain Object <domainObject> with the OrbeonFormInstance <formObject>"
	| formObject domainObject oop assignOop assignment |

	formsHistory add: (Array with: app with: form with: id with: valid).
	forms at: (app,'.',form,'.',id) put: xmlString. 
	"create or get the OrbeonFormInstance and the FieldValuedHolder is created or updated inside this method"
	[formObject := OrbeonHandler default importDataOfFormId: id form: form app: app] on: Error 
		do: [:ex | ^OrbeonPostResult exception: ex].

	formObject ifNil: [^OrbeonPostResult exception: (FormIdNotExistException signal: 'Form [', form, '] of app [', app, '] with id [', id,'] not found')].

	oop := formObject valueAt: 'oop'. "get the oop of the <anOrbeonFormTransition>"
	assignOop := formObject valueAt: 'assignmentOop'. 
	formObject isValid: valid.
	"get the Domain Object with -oop- in the form"
	[domainObject := Object _objectForOop: (Integer fromString: oop).
	assignment := Object _objectForOop: (Integer fromString: assignOop).] on: Error
		do: [:ex | ^OrbeonPostResult exception: ex].

	domainObject orbeonFormInstance: formObject. "domain object <anOrbeonFormTransition> associated with the Form <formObject>"
	formObject assignment: assignment. "set the assignment where the form was edited"
	domainObject processDefinition updateFieldsOf: formObject. "the indexes of the OrbeonFormProcessDefinition are updated here"

	^OrbeonPostResult result: domainObject! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 09/05/2014 05:45'!
requestCache

   "Return the value of the instance variable 'requestCache'."
   ^requestCache! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 09/05/2014 05:45'!
requestCache: newValue

   "Modify the value of the instance variable 'requestCache'."
   requestCache := newValue! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:24'!
reset

	forms := Dictionary new! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:26'!
resetHistory

	formsHistory := OrderedCollection new! !

Object subclass: #OrbeonPostResult
	instanceVariableNames: 'objectResult exception'
	classVariableNames: 'PostExceptions'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApiProcess'!

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 07/15/2015 14:58'!
exception: anException

"	PostExceptions add: anException."

	^super new initialize
		exception: anException;
		yourself! !

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 07/15/2015 14:46'!
postExceptions

	PostExceptions ifNil: [PostExceptions := OrderedCollection new].

	^PostExceptions! !

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:05'!
result: anObject

	^super new initialize
		objectResult: anObject;
		yourself! !

!OrbeonPostResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/07/2015 07:01'!
exception

   "Return the value of the instance variable 'exception'."
   ^exception! !

!OrbeonPostResult methodsFor: 'Updating' stamp: 'BrunoBB 03/07/2015 07:01'!
exception: newValue

   "Modify the value of the instance variable 'exception'."
   exception := newValue! !

!OrbeonPostResult methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:03'!
hasException

	^exception notNil! !

!OrbeonPostResult methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:03'!
isOk

	^objectResult notNil! !

!OrbeonPostResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/07/2015 07:01'!
objectResult

   "Return the value of the instance variable 'objectResult'."
   ^objectResult! !

!OrbeonPostResult methodsFor: 'Updating' stamp: 'BrunoBB 03/07/2015 07:01'!
objectResult: newValue

   "Modify the value of the instance variable 'objectResult'."
   objectResult := newValue! !

Object subclass: #OrbeonTempServiceRegistry
	instanceVariableNames: 'tokens failedTokens results'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApiProcess'!

!OrbeonTempServiceRegistry class methodsFor: 'other' stamp: 'BrunoBB 06/10/2014 17:43'!
default

	Default ifNil: [ Default := super new initialize].

	^Default! !

!OrbeonTempServiceRegistry class methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:10'!
default: anObject

	Default := anObject.

	^Default! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 11/08/2014 09:40'!
addFailedToken: aString

	^failedTokens add: aString! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 11:29'!
createEntryToOrbeonFor: aBpmTaskInstance for: aBpmUser
	| temporaryUUID |

	"generate an UUID in <formId>"
	"aBpmTaskInstance generateFormId. "

	temporaryUUID := UUID new asString.
	" here we register the entry that is called from Orbeon to validate the url link"
	self register: temporaryUUID object: aBpmTaskInstance for: aBpmUser.

	^temporaryUUID! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 18:19'!
failedTokens

   "Return the value of the instance variable 'failedTokens'."
   ^failedTokens! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 18:19'!
failedTokens: newValue

   "Modify the value of the instance variable 'failedTokens'."
   failedTokens := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 12/16/2016 12:57'!
generateXMLFor: anObject for: anOrbeonFormUser
	| result |

	result := '<result>
		<username>', anOrbeonFormUser username,'</username>
		<rol>', anOrbeonFormUser roleName,'</rol>', String lf.

	anObject serviceIds keysAndValuesDo: [:key :value | | conValue |
		conValue := value ifNil: ['nil'] ifNotNil: [value].
		result := result, '<', key, '>', conValue,'</', key, '>',  String lf. ].

	anObject previousFieldValues keysAndValuesDo: [:key :value | | conValue |
		conValue := value ifNil: [''] ifNotNil: [value].
		conValue := (conValue isKindOf: String) ifTrue: [conValue] ifFalse: [conValue printString].
		result := result, '<', key, '>', conValue,'</', key, '>',  String lf. ].	

	"results add: (result, '</result>', anObject asOop printString)."
	^result, '</result>'! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 04/24/2016 07:40'!
getSecureValueForToken: uuidToken
	| result |

	(tokens includesKey: uuidToken) 
	ifTrue: [result := tokens at: uuidToken.
"				failedTokens add: (Array with: 'ok' with: uuidToken). "
				tokens removeKey: uuidToken ifAbsent: [].
	"			results add: (Array with: 'answer' with: result). "
				^result].

	failedTokens add: (Array with: 'failed' with: uuidToken with: TimeStamp current).

	^nil! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:07'!
initialize

	super initialize.

	tokens := Dictionary new.

	failedTokens := OrderedCollection new.
	results := OrderedCollection new.! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 11/08/2014 09:15'!
register: tempUuid object: anObject for: anOrbeonFormUser

	^tokens at: tempUuid put: (self generateXMLFor: anObject for: anOrbeonFormUser)""! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 12/31/2014 15:07'!
results

   "Return the value of the instance variable 'results'."
   ^results! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 12/31/2014 15:07'!
results: newValue

   "Modify the value of the instance variable 'results'."
   results := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/10/2014 17:43'!
tokens

   "Return the value of the instance variable 'tokens'."
   ^tokens! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/10/2014 17:43'!
tokens: newValue

   "Modify the value of the instance variable 'tokens'."
   tokens := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 17:26'!
unregister: token

	^tokens removeKey: token ifAbsent: []! !

WAOrbeonPersistenceLayer subclass: #WAOrbeonProcessLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApiProcess'!

!WAOrbeonProcessLayer class methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:05'!
register
	| application |

	WAAdmin unregister: 'orbeon-gemstone-api'.

	application := WAAdmin register: self at: 'orbeon-gemstone-api'.! !

!WAOrbeonProcessLayer class methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 10:49'!
unregister

	WAAdmin unregister: 'orbeon-gemstone-api'.! !

!WAOrbeonProcessLayer methodsFor: 'other' stamp: 'BrunoBB 12/16/2016 12:57'!
answerXMLErrorWith: uuidToken

"	^'<result>
		<error>', uuidToken,'</error>
	</result>'
"

	^'<result>
		<formid></formid>
		<username></username>
	</result>'! !

!WAOrbeonProcessLayer methodsFor: 'other' stamp: 'brunobb 02/04/2018 14:32'!
associateFormWithTask: aBpmTaskInstance forProcess: aBpmProcessInstace
	"The receiver associate the task <aBpmTaskInstance> with it's form instance in the process <aBpmProcessInstace>.
	This method is used in anonymous process creation.
	If the form <formInstance> is not set with an assignment --> the search will Fail. But an anonymous form does not have anAssignment so here one assignment is enforced"
	| formInstance assigment role |

	formInstance := aBpmTaskInstance externalObject.

	role := aBpmTaskInstance getRoles ifEmpty: [TaskWithNoRoleException signal: 'No roles for this task' ] ifNotEmpty: [:value | value first].

	assigment := (BpmTaskAssignment 
							newFor: aBpmProcessInstace 
							task: aBpmTaskInstance 
							in: (self getFinishedMatrixForApplication: formInstance getApplicationName))
						role: role;
						canUnassign: aBpmTaskInstance canUnassign;
						yourself.

	formInstance assignment: assigment.! !

!WAOrbeonProcessLayer methodsFor: 'url generation' stamp: 'BrunoBB 02/03/2016 09:53'!
generateEmbeddedUrlFor: anOrbeonFormTransition user: user s: seasideS k: seasideK params: postParamsArray
	"http://orbeonIP:port/orbeon/fr/[app]/[formulario]/edit/[formId]
	The form is saved and displayed again as a iframe inside GemStone application"
	| uuid |

	uuid := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: user.

	^self getOrbeonWebServerConfiguration orbeonIP,
			'/orbeon/fr/', 
			(postParamsArray at: 4), '/', 
			(postParamsArray at: 5), '/edit/', 
			(postParamsArray at: 1),'?token=', uuid, '&s=', seasideS,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString! !

!WAOrbeonProcessLayer methodsFor: 'html generation' stamp: 'BrunoBB 09/25/2015 07:39'!
generateHtmlExceptionFor: anException params: anArray

	^'<!!DOCTYPE html>
<html>
<body>

<h1>Exception</h1>
<h2>Application: ', anArray fourth,'</h2>
<h2>Form Name: ', anArray fifth,'</h2>
<h2>Form ID: ', anArray first,'</h2>
<h2>Language: ', anArray second,'</h2>
<h2>Valid: ', anArray third,'</h2>

<p>', anException description,'</p>
<p>', (GsProcess stackReportToLevel: 20),'</p>

</body>
</html>'! !

!WAOrbeonProcessLayer methodsFor: 'html generation' stamp: 'BrunoBB 08/01/2016 10:27'!
generateHtmlFor: anBpmArtifactInstance xml: xmlString params: anArray
	"Generate an HTML that does a redirect to Seaside app with _s and _k parameters.
	In Orbeon the send() command is configured with replace='all' "
	| doc seasideS seasideK url user |

	doc := XMLDOMParser parse: xmlString.
	seasideS := (doc findElementNamed: 's') rawContentString "stringNodes last string".
	seasideK := (doc findElementNamed: 'k') rawContentString "stringNodes last string".
	user := BpmUser getUserNamed: (doc findElementNamed: 'username') rawContentString "stringNodes last string".
	url := user orbeonWebIsLinked
		ifTrue: [self generateLinkedUrlFor_S: seasideS andK: seasideK]
		ifFalse: [self generateEmbeddedUrlFor: anBpmArtifactInstance user: user s: seasideS k: seasideK params: anArray].

	^user orbeonWebIsLinked 
		ifTrue: [self generateHtmlForRedirectTo: url]
		ifFalse: [self generateHtmlIframeParentRefresh: url]! !

!WAOrbeonProcessLayer methodsFor: 'html redirect' stamp: 'BrunoBB 09/25/2015 07:20'!
generateHtmlForRedirectTo: url

	^'<!!DOCTYPE HTML>
<meta charset="UTF-8">
<meta http-equiv="refresh" content="1; url=', url,'">
 <script>
  top.location.href = "', url,'"
</script>
 <title>Page Redirection</title>
 If you are not redirected automatically, follow the <a href=''', url,'''>link to example</a>'! !

!WAOrbeonProcessLayer methodsFor: 'html redirect' stamp: 'BrunoBB 09/25/2015 07:20'!
generateHtmlIframeParentRefresh: url

	^'<!!DOCTYPE HTML>
<meta charset="UTF-8">
<meta http-equiv="refresh" content="1; url=', url,'">
 <script>
  window.location.href = "', url,'"
</script>
 <title>Page Redirection</title>
 If you are not redirected automatically, follow the <a href=''', url,'''>link to example</a>'! !

!WAOrbeonProcessLayer methodsFor: 'url generation' stamp: 'BrunoBB 02/03/2016 09:54'!
generateLinkedUrlFor_S: seasideS andK: seasideK
	"Answer a url to do the redirect to the GemStone application again.
	The Orbeon form is closed and is redirected to GemStone applicaiton"

	^self getGemStoneServerConfiguration gemstoneIP,'/orbeonProcess?_s=', seasideS, '&_k=', seasideK! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 12:40'!
getBpmProcessInstanceOf: processName version: version in: appName withId: processId
	"The receiver answer <aBpmProcessInstance> of the process definition named <processName> with version <version> in application named <appName> with id <processId>.
	If there is none process answer <nil>"
	| processDefinition |

	processDefinition := BpmProcessDefinition getProcessNamed: processName version: version in: appName.
	processDefinition ifNil: [^nil].

	^processDefinition getProcessInstanceWith: processId ifAbsent: [nil]! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 14:28'!
getBpmProcessInstanceOf: processName version: version in: appName withQuery: xmlDocument
	"The receiver answer <aBpmProcessInstance> of the process definition named <processName> with version <version> in application named <appName> with filters contained in <xmlDocument>.
	If there is none process answer <nil>"
	| processDefinition queryFieldValues xPathNodes processFilters result |

	processDefinition := BpmProcessDefinition getProcessNamed: processName version: version in: appName.
	processDefinition ifNil: [^nil].

	xPathNodes := (xmlDocument xPath: '//query') collection ifEmpty: [^nil] ifNotEmpty: [:collection | collection].
	
	processFilters := xPathNodes first elements collection.

	queryFieldValues := (self getProcessFiltersFromCollection: processFilters) ifEmpty: [^nil] ifNotEmpty: [:collection | collection].

	result := Set new.
	queryFieldValues keysAndValuesDo: [:formFieldArray :fieldValue |
		result addAll: (BpmProcessDefinition getFieldsNamed: (formFieldArray at: 2) in: (formFieldArray at: 1) withValue: fieldValue).
	].

	^result
	
"<setvariables>
	<query>
		<number>
			<citizen-appliance>
				<userid>123456</userid>
			</citizen-appliance>
		</number>
		<string>
			<check-basic-data>
				<usercountry>US</usercountry>
			</check-basic-data>
		</string>
	</query>
	<externalvariables>
		<boolean>
			<approved>true</approved>
		</boolean>
		<number>
			<amount>50000</amount>
		</number>
	</externalvariables>
</setvariables>"! !

!WAOrbeonProcessLayer methodsFor: 'other' stamp: 'brunobb 01/14/2018 09:36'!
getFinishedMatrixForApplication: aString

	^self getFinishedMatrixManagerClass getMatrixForApplicationNamed: aString! !

!WAOrbeonProcessLayer methodsFor: 'service-get' stamp: 'BrunoBB 12/16/2016 12:45'!
getOrbeonSecurityToken: uuidToken
	"The security GET service take an uuid as a parameter <uuidToken> and:
	1- Check via lookup if it has associated XML. 
	2- If it so then answer the XML string associate with the token. 
	3- If not then answer a XML string with the same structure as 2 but with empty nodes values."
	<get>
    <path: '/securityToken?token={1}'> 
	<produces: 'text/xml'>
	| serviceRegistry serviceValue |

	serviceRegistry := OrbeonTempServiceRegistry default. 
	"get the XML associate with the token <uuidToken>"
	serviceValue := serviceRegistry getSecureValueForToken: uuidToken. 
	"if the token <uuidToken> is not registered then answer an empty XML with the same structure"
	serviceValue ifNil: [^self answerXMLErrorWith: uuidToken]. 
	"remove the toke <uuidToken> for security reasons -can not be used again-"
	serviceRegistry unregister: uuidToken. 
	
  ^serviceValue "the XML associated with token <uuidToken> with the values of the Orbeon form"! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 14:12'!
getProcessFiltersFromCollection: aCollection
	| processFilters |

	processFilters := Dictionary new.

	aCollection do: [:xmlTypeElement | | stClass |
		stClass := self mapStClassFrom: xmlTypeElement name.
		stClass ifNil: [^processFilters].
		xmlTypeElement elements do: [:eachForm | 
			eachForm elements do: [:eachField |  processFilters at: (Array with: eachForm name with: eachField name) put: (stClass fromString: eachField innerXML)]. 
		].
	].

	^processFilters! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 13:35'!
mapStClassFrom: xmlStringType

	(xmlStringType asLowercase = 'number') ifTrue: [^Number].
 
	(xmlStringType asLowercase = 'string') ifTrue: [^String].

	(xmlStringType asLowercase = 'boolean') ifTrue: [^Boolean].

	(xmlStringType asLowercase = 'date') ifTrue: [^Boolean].

	(xmlStringType asLowercase = 'time') ifTrue: [^Time].

	(xmlStringType asLowercase = 'timestamp') ifTrue: [^TimeStamp].

	^nil! !

!WAOrbeonProcessLayer methodsFor: 'service-post' stamp: 'BrunoBB 02/08/2016 11:30'!
newOrbeonFormId: id language: lan valid: valid app: app form: formName
	"POST service to process an Orben XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- With data context inside the XML (inside the post) generate an url link to the previous page but with domain data updated.
	3- The POST service answer a HTML code with a redirect (with javascript) to the url build in step 2."
	| instance |
	<post>
	<path: '/processform?document={1}&language={2}&valid={3}&app={4}&form={5}'>
	<produces: 'text/html'>

	instance := self getOrbeonApplicationClass getAnyInstanceWith: id formName: formName in: app
						ifNone: [self getOrbeonApplicationClass getAnyDraftWith: id formName: formName in: app
										ifNone: [^self signalNoFormException: formName id: id app: app]].


	^self processAndRedirectForm: instance language: lan valid: valid! !

!WAOrbeonProcessLayer methodsFor: 'service-post' stamp: 'BrunoBB 02/08/2016 11:31'!
newOrbeonFormId: id processId: procId dataFormatVersion: dataFormatVersion language: lan valid: valid app: app formVersion: formVersion form: formName
	"POST service to process an Orben XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- With data context inside the XML (inside the post) generate an url link to the previous page but with domain data updated.
	3- The POST service answer a HTML code with a redirect (with javascript) to the url build in step 2."
	| instance |
	<post>
	<path: '/processform?document={1}&process={2}&data-format-version={3}&language={4}&valid={5}&app={6}&form-version={7}&form={8}'>
	<produces: 'text/html'>

	instance := self getOrbeonApplicationClass getAnyInstanceWith: id formName: formName in: app
						ifNone: [self getOrbeonApplicationClass getAnyDraftWith: id formName: formName in: app
										ifNone: [^self signalNoFormException: formName id: id app: app version: formVersion]].


	^self processAndRedirectForm: instance language: lan valid: valid! !

!WAOrbeonProcessLayer methodsFor: 'service-post' stamp: 'brunobb 02/05/2018 09:28'!
newProcessFromOrbeonFormId: id processId: procId dataFormatVersion: dataFormatVersion language: lan valid: valid app: app formVersion: formVersion form: form
	"POST service to process an Orbeon XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- Get the Process Definition for the Orbeon Instance Form.
	3- Create the Process based on the definition and finish the first transition of the Process -the annonimous user has already sent the finished form-"
	<post>
	<path: '/createprocess?document={1}&process={2}&data-format-version={3}&language={4}&valid={5}&app={6}&form-version={7}&form={8}'>
	<produces: 'text/html'>
	| application formInstance procDefinition newProcess currentTask |

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^NoApplicationException signal: 'No such application [', app, ']'].
	formInstance := application getAnyInstanceWithId: id of: form ifNone: [^NoOrbeonFormException signal: 'No such form [', id, ']'].

	procDefinition := BpmProcessDefinition getBpmProcessForAnonymousStartWith: form in: app.
	newProcess := procDefinition createAndStartProcessInstance: nil "anonymous user ".
	newProcess currentActivities isEmpty ifTrue: [^NoRunningTaskException signal: 'The BpmProcessInstance can not be executed because the collection <currentActivities> is empty'].
	currentTask := newProcess currentActivities last.

	currentTask externalObject: formInstance.
	self associateFormWithTask: currentTask forProcess: newProcess.
	currentTask finalize.
	newProcess generateNextTransitionsFrom: currentTask.
	procDefinition updateFieldsOf: formInstance. "the indexes of the BpmProcessDefinition are updated here"

	^self redirectToStaticMessagePageFor: newProcess! !

!WAOrbeonProcessLayer methodsFor: 'service-post' stamp: 'BrunoBB 04/28/2016 10:50'!
processAndRedirectForm: anOrbeonFormInstance language: language valid: aBoolean
	"The receiver process the form <anOrbeonFormInstance> sent by Orbeon.
	1- Extract from the form the [oop] of the transition associated with the form and get the transition.
	2- Extract from the form the [oop] of the assignment associated with the form and get the assignment.
	3- Connect the form, the transitions and the assignment.
	4- Update the collection's field of the process.
	5- Answer an HTML with the redirect to be performed by Orbeon (and then Orbeon do the redirect to the Seaside application)"
	| artifactOop assignOop artifact assignment serviceResult |

	artifactOop := anOrbeonFormInstance valueAt: 'oop'. "get the oop of the <anOrbeonFormTransition>"
	assignOop := anOrbeonFormInstance valueAt: 'assignmentOop'. "get the oop of the <anOrbeonProcessAssignment>"
		"get the Domain Object with -oop- in the form"
	[artifact := Object _objectForOop: (Integer fromString: artifactOop).
	assignment := Object _objectForOop: (Integer fromString: assignOop).] on: Error
		do: [:ex | ^BpmCodeEvaluationResult exception: ex].

	artifact externalObject: anOrbeonFormInstance. "artifact <aBpmArtifactInstance> associated with the Form <instance>"
	anOrbeonFormInstance assignment: assignment. "set the assignment where the form was edited"
	artifact processDefinition updateFieldsOf: anOrbeonFormInstance. "the indexes of the BpmProcessDefinition are updated here"
	serviceResult := BpmCodeEvaluationResult result: artifact.
	 "answer an HTML code with a redirect to the previous (but updated) page "
	 ^self generateHtmlFor: serviceResult result
			xml: anOrbeonFormInstance xmlString 
			params: (Array with: anOrbeonFormInstance id with: language with: aBoolean with: anOrbeonFormInstance getApplicationName with: anOrbeonFormInstance formName)! !

!WAOrbeonProcessLayer methodsFor: 'html redirect' stamp: 'BrunoBB 07/23/2016 14:09'!
redirectToStaticMessagePageFor: aBpmProcessInstance
	| title text data |

	title := 'New Process Created' .
	text := 'Process Id [', aBpmProcessInstance id printString, '] (', aBpmProcessInstance getApplicationName, ' | ', aBpmProcessInstance getDefinitionName, ')'.
	data := 'You will receive a mail for each process news'.

	^self generateHtmlForRedirectTo: self getGemStoneServerConfiguration gemstoneIP, '/processMessage?title=', title, '&text=', text, '&data=', data.! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 12:11'!
respondProcessNotFound: processId query: xmlDocument
	"The receiver answer aXml string with process NOT found with id <processId> or filters <xmlDocument>"! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 12:13'!
respondSetOk: processId query: xmlDocument
	"The receiver answer aXml string with Ok to operation set external variables for process with id <processId> or filters <xmlDocument>"! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 12:13'!
respondXmlParseError: badXmlString
	"The receiver answer aXml string with error at parse time for Xml <badXmlString>"! !

!WAOrbeonProcessLayer methodsFor: 'service-put' stamp: 'BrunoBB 03/18/2017 13:53'!
saveFinalFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| application definition instance version |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml?valid={4}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self signalNoApplicationException: app].
	version := Number fromString: (self requestContext request headerAt: 'orbeon-form-definition-version').
	definition := application getDefinitionNamed: formName withVersion: version ifNone: [^self signalNoFormException: formName id: id app: app version: version].
	instance := definition 
				getInstanceWithId: id 
				ifNone: [definition getDraftWithId: id ifNone: [OrbeonFormInstance newFor: definition withId: id]].

	"execute the audit options. if <xmlString> is nil --> is a new form"
	(instance xmlString notNil and:[self apiConfiguration isInstanceAuditEnableFor: formName in: app]) 
	ifTrue: [self auditStorage addInstanceAudit: instance cloneForAudit].

	instance xmlString: self requestContext request rawBody;
		draft: 'N';
		definition: definition;
		version: version;
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		isValid: aBoolean;
		updateLastModifiedTime;
		processXML.

	definition removeDraft: instance. "this is the final version so we remove the current draft if any"! !

!WAOrbeonProcessLayer methodsFor: 'service-post' stamp: 'brunobb 02/05/2018 12:07'!
setExternalVariableFor: processName version: version in: appName processId: processId
	"The receiver set the external variables contained in the body <rawBody> of process named <processName> version <version> in application named <appName> with id <processId>.
	If <processId> is 0 then the body <rawBody> it contain additional filters to get the <BpmProcessInstances>"
	| processInstance xmlDocument |
	<post>
	<path: '/setvariables?processname={1}&version={2}&app={3}&processid={4}'>
	<produces: 'application/xml'>

	[xmlDocument := XMLDOMParser parse: self requestContext request rawBody] on: Error do: [:ex | ^self respondXmlParseError: self requestContext request rawBody].
	
	processInstance := (processId = 0)
		ifTrue: [self getBpmProcessInstanceOf: processName version: version in: appName withQuery: xmlDocument] 
		ifFalse: [self getBpmProcessInstanceOf: processName version: version in: appName withId: processId].

	processInstance ifNil: [^self respondProcessNotFound: processId query: xmlDocument]. 

	self setExternalVariablesTo: processInstance with: xmlDocument.

	^self respondSetOk: processId query: xmlDocument! !

!WAOrbeonProcessLayer methodsFor: 'external variables' stamp: 'brunobb 02/05/2018 12:02'!
setExternalVariablesTo: aBpmProcessInstance with: xmlDocument! !
